import { IgrListPanelItemModel } from "./igr-list-panel-item-model";
import { IgrListPanel } from "./igr-list-panel";
import { ListPanelItemEventArgs as ListPanelItemEventArgs_internal } from "./ListPanelItemEventArgs";
import { ensureBool } from "igniteui-react-core";
/**
 * Event arguments for the SelectionChanged event.
*/
export class IgrListPanelItemEventArgs {
    createImplementation() {
        return new ListPanelItemEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get itemInfo() {
        const r = this.i.itemInfo;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrListPanelItemModel();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set itemInfo(v) {
        v == null ? this.i.itemInfo = null : this.i.itemInfo = v.i;
    }
    get listPanel() {
        const r = this.i.listPanel;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrListPanel({});
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set listPanel(v) {
        v == null ? this.i.listPanel = null : this.i.listPanel = v.i;
    }
    get isLeftButton() {
        return this.i.isLeftButton;
    }
    set isLeftButton(v) {
        this.i.isLeftButton = ensureBool(v);
    }
    get isDoubleClick() {
        return this.i.isDoubleClick;
    }
    set isDoubleClick(v) {
        this.i.isDoubleClick = ensureBool(v);
    }
}
