import { ListPanelItemModel as ListPanelItemModel_internal } from "./ListPanelItemModel";
import { ensureBool } from "igniteui-react-core";
export class IgrListPanelItemModel {
    createImplementation() {
        return new ListPanelItemModel_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get dataRow() {
        return this.i.v;
    }
    set dataRow(v) {
        this.i.v = +v;
    }
    get rowHeight() {
        return this.i.t;
    }
    set rowHeight(v) {
        this.i.t = +v;
    }
    get rowObject() {
        return this.i.x;
    }
    set rowObject(v) {
        this.i.x = v;
    }
    get isModelDirty() {
        return this.i.m;
    }
    set isModelDirty(v) {
        this.i.m = ensureBool(v);
    }
    get left() {
        return this.i.s;
    }
    set left(v) {
        this.i.s = +v;
    }
    get top() {
        return this.i.u;
    }
    set top(v) {
        this.i.u = +v;
    }
    get isActivated() {
        return this.i.j;
    }
    set isActivated(v) {
        this.i.j = ensureBool(v);
    }
    get isActivationSupported() {
        return this.i.k;
    }
    set isActivationSupported(v) {
        this.i.k = ensureBool(v);
    }
    get isSelected() {
        return this.i.n;
    }
    set isSelected(v) {
        this.i.n = ensureBool(v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}
