import * as React from 'react';
import { delegateCombine, delegateRemove } from "igniteui-react-core";
import { PropertyEditorValueType_$type } from "./PropertyEditorValueType";
import { IgrPropertyEditorDescriptionObject } from "./igr-property-editor-description-object";
import { IgrPropertyEditorDescriptionObjectCollection } from "./igr-property-editor-description-object-collection";
import { IgrPropertyEditorPropertyDescriptionCollection } from "./igr-property-editor-property-description-collection";
import { IgrPropertyEditorPropertyDescriptionButtonClickEventArgs } from "./igr-property-editor-property-description-button-click-event-args";
import { IgrPropertyEditorPropertyDescriptionChangedEventArgs } from "./igr-property-editor-property-description-changed-event-args";
import { IgrPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs } from "./igr-property-editor-property-description-target-property-updating-event-args";
import { IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs } from "./igr-property-editor-property-description-coercing-value-event-args";
import { PropertyEditorPropertyDescription } from "./PropertyEditorPropertyDescription";
import { TypeRegistrar } from "igniteui-react-core";
import { NamePatcher, getModifiedProps, isValidProp, ensureEnum, ensureBool, toSpinal, initializePropertiesFromCss } from "igniteui-react-core";
import { PropertyEditorDescriptionObjectCollection as PropertyEditorDescriptionObjectCollection_internal } from "./PropertyEditorDescriptionObjectCollection";
import { PropertyEditorDescriptionObject } from "./PropertyEditorDescriptionObject";
import { SyncableObservableCollection$1 } from "igniteui-react-core";
import { PropertyEditorPropertyDescriptionCollection as PropertyEditorPropertyDescriptionCollection_internal } from "./PropertyEditorPropertyDescriptionCollection";
export class IgrPropertyEditorPropertyDescription extends React.Component {
    createImplementation() {
        return new PropertyEditorPropertyDescription();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    } /**
                                 * @hidden
                                 */
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    onImplementationCreated() {
    }
    constructor(props) {
        super(props);
        this.mounted = false;
        this._complexValues = null;
        this._coercedComplexValues = null;
        this._properties = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._buttonClicked = null;
        this._buttonClicked_wrapped = null;
        this._changed = null;
        this._changed_wrapped = null;
        this._targetPropertyUpdating = null;
        this._targetPropertyUpdating_wrapped = null;
        this._coercingValue = null;
        this._coercingValue_wrapped = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    componentDidMount() {
        this.mounted = true;
        for (const p of Object.keys(this.props)) {
            if (isValidProp(this, p)) {
                this[p] = this.props[p];
            }
        }
    }
    shouldComponentUpdate(nextProps, nextState) {
        const mod = getModifiedProps(this.props, nextProps);
        for (const p of Object.keys(mod)) {
            if (isValidProp(this, p)) {
                this[p] = mod[p];
            }
        }
        return true;
    }
    render() {
        return null;
    }
    /**
     * Gets or sets the unique name of the mapping.
    */
    get name() {
        return this.i.a0;
    }
    set name(v) {
        this.i.a0 = v;
    }
    get propertyPath() {
        return this.i.a3;
    }
    set propertyPath(v) {
        this.i.a3 = v;
    }
    get label() {
        return this.i.az;
    }
    set label(v) {
        this.i.az = v;
    }
    get subtitle() {
        return this.i.a4;
    }
    set subtitle(v) {
        this.i.a4 = v;
    }
    get valueType() {
        return this.i.w;
    }
    set valueType(v) {
        this.i.w = ensureEnum(PropertyEditorValueType_$type, v);
    }
    get coercedValueType() {
        return this.i.v;
    }
    set coercedValueType(v) {
        this.i.v = ensureEnum(PropertyEditorValueType_$type, v);
    }
    get propertyDescriptionType() {
        return this.i.a2;
    }
    set propertyDescriptionType(v) {
        this.i.a2 = v;
    }
    get shouldOverrideDefaultEditor() {
        return this.i.ab;
    }
    set shouldOverrideDefaultEditor(v) {
        this.i.ab = ensureBool(v);
    }
    get elementDescriptionType() {
        return this.i.ay;
    }
    set elementDescriptionType(v) {
        this.i.ay = v;
    }
    get dropDownNames() {
        return this.i.c;
    }
    set dropDownNames(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.c = v;
    }
    get dropDownValues() {
        return this.i.d;
    }
    set dropDownValues(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.d = v;
    }
    get primitiveValue() {
        return this.i.ar;
    }
    set primitiveValue(v) {
        this.i.ar = v;
    }
    get coercedPrimitiveValue() {
        return this.i.ap;
    }
    set coercedPrimitiveValue(v) {
        this.i.ap = v;
    }
    get min() {
        return this.i.al;
    }
    set min(v) {
        this.i.al = +v;
    }
    get editorWidth() {
        return this.i.ai;
    }
    set editorWidth(v) {
        this.i.ai = +v;
    }
    get labelWidth() {
        return this.i.aj;
    }
    set labelWidth(v) {
        this.i.aj = +v;
    }
    get max() {
        return this.i.ak;
    }
    set max(v) {
        this.i.ak = +v;
    }
    get step() {
        return this.i.am;
    }
    set step(v) {
        this.i.am = +v;
    }
    get complexValue() {
        const r = this.i.i;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrPropertyEditorDescriptionObject();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set complexValue(v) {
        v == null ? this.i.i = null : this.i.i = v.i;
    }
    get coercedComplexValue() {
        const r = this.i.h;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrPropertyEditorDescriptionObject();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set coercedComplexValue(v) {
        v == null ? this.i.h = null : this.i.h = v.i;
    }
    get complexValues() {
        if (this._complexValues === null) {
            let coll = new IgrPropertyEditorDescriptionObjectCollection();
            let innerColl = this.i.m;
            if (!innerColl) {
                innerColl = new PropertyEditorDescriptionObjectCollection_internal();
            }
            this._complexValues = coll._fromInner(innerColl);
            this.i.m = innerColl;
        }
        return this._complexValues;
    }
    set complexValues(v) {
        if (this._complexValues !== null) {
            this._complexValues._setSyncTarget(null);
            this._complexValues = null;
        }
        let coll = new IgrPropertyEditorDescriptionObjectCollection();
        this._complexValues = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(PropertyEditorDescriptionObject.$type);
        let innerColl = this.i.m;
        if (!innerColl) {
            innerColl = new PropertyEditorDescriptionObjectCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._complexValues._setSyncTarget(syncColl);
        this.i.m = innerColl;
    }
    get coercedComplexValues() {
        if (this._coercedComplexValues === null) {
            let coll = new IgrPropertyEditorDescriptionObjectCollection();
            let innerColl = this.i.l;
            if (!innerColl) {
                innerColl = new PropertyEditorDescriptionObjectCollection_internal();
            }
            this._coercedComplexValues = coll._fromInner(innerColl);
            this.i.l = innerColl;
        }
        return this._coercedComplexValues;
    }
    set coercedComplexValues(v) {
        if (this._coercedComplexValues !== null) {
            this._coercedComplexValues._setSyncTarget(null);
            this._coercedComplexValues = null;
        }
        let coll = new IgrPropertyEditorDescriptionObjectCollection();
        this._coercedComplexValues = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(PropertyEditorDescriptionObject.$type);
        let innerColl = this.i.l;
        if (!innerColl) {
            innerColl = new PropertyEditorDescriptionObjectCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._coercedComplexValues._setSyncTarget(syncColl);
        this.i.l = innerColl;
    }
    get useCoercedValue() {
        return this.i.ac;
    }
    set useCoercedValue(v) {
        this.i.ac = ensureBool(v);
    }
    get properties() {
        if (this._properties === null) {
            let coll = new IgrPropertyEditorPropertyDescriptionCollection();
            let innerColl = this.i.r;
            if (!innerColl) {
                innerColl = new PropertyEditorPropertyDescriptionCollection_internal();
            }
            this._properties = coll._fromInner(innerColl);
            this.i.r = innerColl;
        }
        return this._properties;
    }
    set properties(v) {
        if (this._properties !== null) {
            this._properties._setSyncTarget(null);
            this._properties = null;
        }
        let coll = new IgrPropertyEditorPropertyDescriptionCollection();
        this._properties = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(PropertyEditorPropertyDescription.$type);
        let innerColl = this.i.r;
        if (!innerColl) {
            innerColl = new PropertyEditorPropertyDescriptionCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._properties._setSyncTarget(syncColl);
        this.i.r = innerColl;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.complexValue && this.complexValue.name && this.complexValue.name == name) {
            return this.complexValue;
        }
        if (this.coercedComplexValue && this.coercedComplexValue.name && this.coercedComplexValue.name == name) {
            return this.coercedComplexValue;
        }
        if (this.complexValues != null && this.complexValues.findByName && this.complexValues.findByName(name)) {
            return this.complexValues.findByName(name);
        }
        if (this.coercedComplexValues != null && this.coercedComplexValues.findByName && this.coercedComplexValues.findByName(name)) {
            return this.coercedComplexValues.findByName(name);
        }
        if (this.properties != null && this.properties.findByName && this.properties.findByName(name)) {
            return this.properties.findByName(name);
        }
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("PropertyEditorPropertyDescription");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    get buttonClicked() {
        return this._buttonClicked;
    }
    set buttonClicked(ev) {
        if (this._buttonClicked_wrapped !== null) {
            this.i.buttonClicked = delegateRemove(this.i.buttonClicked, this._buttonClicked_wrapped);
            this._buttonClicked_wrapped = null;
            this._buttonClicked = null;
        }
        this._buttonClicked = ev;
        this._buttonClicked_wrapped = (o, e) => {
            let outerArgs = new IgrPropertyEditorPropertyDescriptionButtonClickEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeButtonClicked) {
                this.beforeButtonClicked(this, outerArgs);
            }
            if (this._buttonClicked) {
                this._buttonClicked(this, outerArgs);
            }
        };
        this.i.buttonClicked = delegateCombine(this.i.buttonClicked, this._buttonClicked_wrapped);
        ;
    }
    get changed() {
        return this._changed;
    }
    set changed(ev) {
        if (this._changed_wrapped !== null) {
            this.i.changed = delegateRemove(this.i.changed, this._changed_wrapped);
            this._changed_wrapped = null;
            this._changed = null;
        }
        this._changed = ev;
        this._changed_wrapped = (o, e) => {
            let outerArgs = new IgrPropertyEditorPropertyDescriptionChangedEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeChanged) {
                this.beforeChanged(this, outerArgs);
            }
            if (this._changed) {
                this._changed(this, outerArgs);
            }
        };
        this.i.changed = delegateCombine(this.i.changed, this._changed_wrapped);
        ;
    }
    get targetPropertyUpdating() {
        return this._targetPropertyUpdating;
    }
    set targetPropertyUpdating(ev) {
        if (this._targetPropertyUpdating_wrapped !== null) {
            this.i.targetPropertyUpdating = delegateRemove(this.i.targetPropertyUpdating, this._targetPropertyUpdating_wrapped);
            this._targetPropertyUpdating_wrapped = null;
            this._targetPropertyUpdating = null;
        }
        this._targetPropertyUpdating = ev;
        this._targetPropertyUpdating_wrapped = (o, e) => {
            let outerArgs = new IgrPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeTargetPropertyUpdating) {
                this.beforeTargetPropertyUpdating(this, outerArgs);
            }
            if (this._targetPropertyUpdating) {
                this._targetPropertyUpdating(this, outerArgs);
            }
        };
        this.i.targetPropertyUpdating = delegateCombine(this.i.targetPropertyUpdating, this._targetPropertyUpdating_wrapped);
        ;
    }
    get coercingValue() {
        return this._coercingValue;
    }
    set coercingValue(ev) {
        if (this._coercingValue_wrapped !== null) {
            this.i.coercingValue = delegateRemove(this.i.coercingValue, this._coercingValue_wrapped);
            this._coercingValue_wrapped = null;
            this._coercingValue = null;
        }
        this._coercingValue = ev;
        this._coercingValue_wrapped = (o, e) => {
            let outerArgs = new IgrPropertyEditorPropertyDescriptionCoercingValueEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeCoercingValue) {
                this.beforeCoercingValue(this, outerArgs);
            }
            if (this._coercingValue) {
                this._coercingValue(this, outerArgs);
            }
        };
        this.i.coercingValue = delegateCombine(this.i.coercingValue, this._coercingValue_wrapped);
        ;
    }
}
