import { IgrToolAction } from "./igr-tool-action";
import { ToolActionCheckbox } from "./ToolActionCheckbox";
import { ensureBool, brushToString, stringToBrush } from "igniteui-react-core";
export class IgrToolActionCheckbox extends IgrToolAction {
    createImplementation() {
        return new ToolActionCheckbox();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets if the tool action is checked.
    */
    get isChecked() {
        return this.i.g6;
    }
    set isChecked(v) {
        this.i.g6 = ensureBool(v);
    }
    /**
     * Gets or sets the background color of the checkbox when in the unchecked state.
    */
    get uncheckedBackgroundColor() {
        return brushToString(this.i.ho);
    }
    set uncheckedBackgroundColor(v) {
        this.i.ho = stringToBrush(v);
    }
    /**
     * Gets the actual background color of the checkbox when in the unchecked state.
    */
    get actualUncheckedBackgroundColor() {
        return brushToString(this.i.hk);
    }
    set actualUncheckedBackgroundColor(v) {
        this.i.hk = stringToBrush(v);
    }
    /**
     * Gets or sets the background color of the checkbox when in the checked state.
    */
    get checkedBackgroundColor() {
        return brushToString(this.i.hm);
    }
    set checkedBackgroundColor(v) {
        this.i.hm = stringToBrush(v);
    }
    /**
     * Gets the actual background color of the checkbox when in the checked state.
    */
    get actualCheckedBackgroundColor() {
        return brushToString(this.i.hi);
    }
    set actualCheckedBackgroundColor(v) {
        this.i.hi = stringToBrush(v);
    }
    /**
     * Gets or sets the border color of the checkbox when in the unchecked state.
    */
    get uncheckedBorderColor() {
        return brushToString(this.i.hp);
    }
    set uncheckedBorderColor(v) {
        this.i.hp = stringToBrush(v);
    }
    /**
     * Gets the actual border color of the checkbox when in the unchecked state.
    */
    get actualUncheckedBorderColor() {
        return brushToString(this.i.hl);
    }
    set actualUncheckedBorderColor(v) {
        this.i.hl = stringToBrush(v);
    }
    /**
     * Gets or sets the border color of the checkbox when in the checked state.
    */
    get checkedBorderColor() {
        return brushToString(this.i.hn);
    }
    set checkedBorderColor(v) {
        this.i.hn = stringToBrush(v);
    }
    /**
     * Gets the actual border color of the checkbox when in the checked state.
    */
    get actualCheckedBorderColor() {
        return brushToString(this.i.hj);
    }
    set actualCheckedBorderColor(v) {
        this.i.hj = stringToBrush(v);
    }
}
