import { IgrLayoutSelectedItemsCollection } from "./igr-layout-selected-items-collection";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionCombo } from "./ToolActionCombo";
import { LayoutSelectedItemsCollection as LayoutSelectedItemsCollection_internal } from "./LayoutSelectedItemsCollection";
import { Base } from "igniteui-react-core";
import { SyncableObservableCollection$1 } from "igniteui-react-core";
export class IgrToolActionCombo extends IgrToolAction {
    createImplementation() {
        return new ToolActionCombo();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
        this._selectedValues = null;
    }
    /**
     * Gets or sets if the tool action is checked.
    */
    get dataSource() {
        return this.i.itemsSource;
    }
    set dataSource(v) {
        this.i.itemsSource = v;
    }
    /**
     * Gets or sets the field to use to get the displayed values.
    */
    get displayMemberPath() {
        return this.i.g9;
    }
    set displayMemberPath(v) {
        this.i.g9 = v;
    }
    /**
     * Gets or sets the field to use to get the values to use.
    */
    get valueMemberPath() {
        return this.i.hd;
    }
    set valueMemberPath(v) {
        this.i.hd = v;
    }
    /**
    
    */
    get selectedValues() {
        if (this._selectedValues === null) {
            let coll = new IgrLayoutSelectedItemsCollection();
            let innerColl = this.i.g5;
            if (!innerColl) {
                innerColl = new LayoutSelectedItemsCollection_internal();
            }
            this._selectedValues = coll._fromInner(innerColl);
            this.i.g5 = innerColl;
        }
        return this._selectedValues;
    }
    set selectedValues(v) {
        if (this._selectedValues !== null) {
            this._selectedValues._setSyncTarget(null);
            this._selectedValues = null;
        }
        let coll = new IgrLayoutSelectedItemsCollection();
        this._selectedValues = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(Base.$type);
        let innerColl = this.i.g5;
        if (!innerColl) {
            innerColl = new LayoutSelectedItemsCollection_internal();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._selectedValues._setSyncTarget(syncColl);
        this.i.g5 = innerColl;
    }
}
