import { delegateCombine, delegateRemove } from "igniteui-react-core";
import { IgrToolActionPopupOpeningEventArgs } from "./igr-tool-action-popup-opening-event-args";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionIconButton } from "./ToolActionIconButton";
export class IgrToolActionIconButton extends IgrToolAction {
    createImplementation() {
        return new ToolActionIconButton();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
        this._popupOpening = null;
        this._popupOpening_wrapped = null;
    }
    /**
     * Gets or sets how long it takes before the tooltip is displayed (in milliseconds).
    */
    get tooltipDelay() {
        return this.i.ib;
    }
    set tooltipDelay(v) {
        this.i.ib = +v;
    }
    /**
     * Gets the actual delay before the tooltip is displayed (in milliseconds).
    */
    get actualTooltipDelay() {
        return this.i.ia;
    }
    set actualTooltipDelay(v) {
        this.i.ia = +v;
    }
    get contentPaddingLeft() {
        return this.i.h4;
    }
    set contentPaddingLeft(v) {
        this.i.h4 = +v;
    }
    get actualContentPaddingLeft() {
        return this.i.h0;
    }
    set actualContentPaddingLeft(v) {
        this.i.h0 = +v;
    }
    get contentPaddingTop() {
        return this.i.h6;
    }
    set contentPaddingTop(v) {
        this.i.h6 = +v;
    }
    get actualContentPaddingTop() {
        return this.i.h2;
    }
    set actualContentPaddingTop(v) {
        this.i.h2 = +v;
    }
    get contentPaddingRight() {
        return this.i.h5;
    }
    set contentPaddingRight(v) {
        this.i.h5 = +v;
    }
    get actualContentPaddingRight() {
        return this.i.h1;
    }
    set actualContentPaddingRight(v) {
        this.i.h1 = +v;
    }
    get contentPaddingBottom() {
        return this.i.h3;
    }
    set contentPaddingBottom(v) {
        this.i.h3 = +v;
    }
    get actualContentPaddingBottom() {
        return this.i.hz;
    }
    set actualContentPaddingBottom(v) {
        this.i.hz = +v;
    }
    get isOpen() {
        return this.i.a7;
    }
    cleanUp() {
        this.i.e0();
    }
    openSubMenu() {
        this.i.f0();
    }
    closeSubmenu() {
        this.i.e2();
    }
    exportVisualData() {
        let iv = this.i.ck();
        return (iv);
    }
    get popupOpening() {
        return this._popupOpening;
    }
    set popupOpening(ev) {
        if (this._popupOpening_wrapped !== null) {
            this.i.popupOpening = delegateRemove(this.i.popupOpening, this._popupOpening_wrapped);
            this._popupOpening_wrapped = null;
            this._popupOpening = null;
        }
        this._popupOpening = ev;
        this._popupOpening_wrapped = (o, e) => {
            let outerArgs = new IgrToolActionPopupOpeningEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforePopupOpening) {
                this.beforePopupOpening(this, outerArgs);
            }
            if (this._popupOpening) {
                this._popupOpening(this, outerArgs);
            }
        };
        this.i.popupOpening = delegateCombine(this.i.popupOpening, this._popupOpening_wrapped);
        ;
    }
}
