import { IgrListPanelItemModel } from "./igr-list-panel-item-model";
import { IgrListPanel } from "./igr-list-panel";
import { ListPanelItemEventArgs as ListPanelItemEventArgs_internal } from "./ListPanelItemEventArgs";
import { ensureBool } from "igniteui-react-core";
/**
 * Event arguments for the SelectionChanged event.
*/
var IgrListPanelItemEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrListPanelItemEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrListPanelItemEventArgs.prototype.createImplementation = function () {
        return new ListPanelItemEventArgs_internal();
    };
    Object.defineProperty(IgrListPanelItemEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanelItemEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrListPanelItemEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrListPanelItemEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrListPanelItemEventArgs.prototype, "itemInfo", {
        get: function () {
            var r = this.i.itemInfo;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrListPanelItemModel();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.itemInfo = null : this.i.itemInfo = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanelItemEventArgs.prototype, "listPanel", {
        get: function () {
            var r = this.i.listPanel;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrListPanel({});
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.listPanel = null : this.i.listPanel = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanelItemEventArgs.prototype, "isLeftButton", {
        get: function () {
            return this.i.isLeftButton;
        },
        set: function (v) {
            this.i.isLeftButton = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanelItemEventArgs.prototype, "isDoubleClick", {
        get: function () {
            return this.i.isDoubleClick;
        },
        set: function (v) {
            this.i.isDoubleClick = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrListPanelItemEventArgs;
}());
export { IgrListPanelItemEventArgs };
