import { __extends, __values } from "tslib";
import * as React from 'react';
import { ensureEnum, brushToString, stringToBrush, ensureBool, initializePropertiesFromCss, NamePatcher, isValidProp, toSpinal, getModifiedProps } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { ReactRenderer, ReactWrapper } from "igniteui-react-core";
import { Base, delegateCombine, delegateRemove } from "igniteui-react-core";
import { ListPanel } from './ListPanel';
import { SyncableObservableCollection$1 } from "igniteui-react-core";
import { IgrListPanelTemplateItemUpdatingEventArgs } from './igr-list-panel-template-item-updating-event-args';
import { ListPanelOrientation_$type } from './ListPanelOrientation';
import { IgrListPanelContentRefreshedEventArgs } from './igr-list-panel-content-refreshed-event-args';
import { IgrListPanelTemplateWidthRequestedEventArgs } from './igr-list-panel-template-width-requested-event-args';
import { IgrListPanelTemplateHeightRequestedEventArgs } from './igr-list-panel-template-height-requested-event-args';
import { LocalDataSource } from "igniteui-react-core";
import { Scroller } from "igniteui-react-core";
import { ScrollbarStyle_$type } from "igniteui-react-core";
import { ListPanelScrollerKeyboardListener } from './ListPanelScrollerKeyboardListener';
import { IgrListPanelItemEventArgs } from './igr-list-panel-item-event-args';
import { IgrListPanelActiveRowChangedEventArgs } from './igr-list-panel-active-row-changed-event-args';
import { IgrListPanelSelectionChangedEventArgs } from './igr-list-panel-selection-changed-event-args';
import { IgrListPanelSelectedKeysChangedEventArgs } from './igr-list-panel-selected-keys-changed-event-args';
import { IgrListPanelSelectedItemsChangedEventArgs } from './igr-list-panel-selected-items-changed-event-args';
import { IgrListPanelPrimaryKeyValue } from './igr-list-panel-primary-key-value';
import { IgrListPanelSelectedKeysCollection } from './igr-list-panel-selected-keys-collection';
import { ListPanelPrimaryKeyValue } from './ListPanelPrimaryKeyValue';
import { ListPanelSelectedKeysCollection as ListPanelSelectedKeysCollection_internal } from './ListPanelSelectedKeysCollection';
import { ListPanelSelectionMode_$type } from './ListPanelSelectionMode';
import { ListPanelActivationMode_$type } from './ListPanelActivationMode';
import { ListPanelSelectionBehavior_$type } from './ListPanelSelectionBehavior';
import { IgrListPanelSelectedItemsCollection } from './igr-list-panel-selected-items-collection';
import { ListPanelSelectedItemsCollection as ListPanelSelectedItemsCollection_internal } from './ListPanelSelectedItemsCollection';
var IgrListPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrListPanel, _super);
    function IgrListPanel(props) {
        var _this = _super.call(this, props) || this;
        _this._implementation = null;
        _this._reactRenderer = null;
        _this._scroller = null;
        _this._mounted = true;
        _this._selectedItems = null;
        _this._selectedKeys = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._selectedItemsChanged = null;
        _this._selectedItemsChanged_wrapped = null;
        _this._selectedKeysChanged = null;
        _this._selectedKeysChanged_wrapped = null;
        _this._selectionChanged = null;
        _this._selectionChanged_wrapped = null;
        _this._activeRowChanged = null;
        _this._activeRowChanged_wrapped = null;
        _this._contentRefreshed = null;
        _this._contentRefreshed_wrapped = null;
        _this._rowUpdating = null;
        _this._rowUpdating_wrapped = null;
        _this._itemWidthRequested = null;
        _this._itemWidthRequested_wrapped = null;
        _this._itemHeightRequested = null;
        _this._itemHeightRequested_wrapped = null;
        _this._itemClicked = null;
        _this._itemClicked_wrapped = null;
        _this._actualPrimaryKeyChange = null;
        _this._actualPrimaryKeyChange_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.viewportManager = _this;
        _this._implementation.externalListPanel = _this;
        _this._implementation.externalObject = _this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        //var multiColumnComboBox = this.i;
        //multiColumnComboBox.notifySizeChanged();
        if (props) {
            _this.initializeProperties();
        }
        _this._initialized = true;
        return _this;
    }
    IgrListPanel.prototype.setScrollbarStyle = function (style) {
        if (this._scroller) {
            this._scroller.scrollbarStyle = style;
        }
    };
    IgrListPanel.prototype.setScrollbarColor = function (color) {
        if (this._scroller) {
            this._scroller.scrollbarBrush = color;
        }
    };
    IgrListPanel.prototype.createLocalDataSource = function (itemsSource, schemaIncludedProperties) {
        var lds = new LocalDataSource();
        lds.schemaIncludedProperties = schemaIncludedProperties;
        lds.dataSource = itemsSource;
        return lds;
    };
    IgrListPanel.prototype.onContentSizeChanged = function () {
        var width = this.i.absoluteWidth;
        var height = this.i.absoluteHeight;
        if (this._scroller != null &&
            !isNaN(width) && !isNaN(height)) {
            this._scroller.contentWidth = width;
            this._scroller.contentHeight = height;
        }
    };
    Object.defineProperty(IgrListPanel.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this.notifySizeChanged();
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this.notifySizeChanged();
            }
        },
        enumerable: false,
        configurable: true
    });
    IgrListPanel.prototype.ensureStretch = function () {
        this.width = "100%";
        this.height = "100%";
    };
    IgrListPanel.prototype._getMainRef = function (ref) {
        this._elRef = ref;
        this.verifyReferences();
    };
    IgrListPanel.prototype.render = function () {
        var div = React.createElement("div", {
            ref: this._getMainRef,
            className: "ig-list-panel igr-list-panel",
        });
        return div;
    };
    IgrListPanel.prototype.moveViewportTo = function (x, y) {
        this._scroller.scrollTo(x, y);
    };
    IgrListPanel.prototype.verifyReferences = function () {
        var _this = this;
        if (this._elRef) {
            this._reactRenderer = new ReactRenderer(this._elRef, document, true, {});
            if (document) {
                this._elRef.style.display = "block";
                this._elRef.style.width = "100%";
                this._elRef.style.height = "100%";
            }
            // render needs to fire again after the portalManager is created. 
            this.i.provideContainer(this._reactRenderer);
            var scroller = new Scroller();
            scroller.scrollbarStyle = this.scrollbarStyle;
            this._scroller = scroller;
            this._scroller.keyboardListener = new ListPanelScrollerKeyboardListener(this.i);
            scroller.provideContainer(this._reactRenderer);
            this._content = (this.i.view.contentGrid);
            scroller.provideContent(new ReactWrapper(this._content, this._reactRenderer));
            scroller.onScrolling = function () { return _this.onScroll(); };
            scroller.onScrollStart = function () { return _this.onScrollStart(); };
            scroller.onScrollStop = function () { return _this.onScrollStop(); };
            scroller.viewportWidth = this._reactRenderer.rootWrapper.width();
            scroller.viewportHeight = this._reactRenderer.rootWrapper.height();
            this.notifySizeChanged();
            this._reactRenderer.addSizeWatcher(function () {
                _this.notifySizeChanged();
            });
        }
    };
    IgrListPanel.prototype.onScroll = function () {
        var top = this._scroller.scrollTop;
        var left = this._scroller.scrollLeft;
        var width = this._scroller.viewportWidth;
        var height = this._scroller.viewportHeight;
        //console.log("top:" + top);
        this.i.setViewport(left, top, left + width, top + height);
    };
    IgrListPanel.prototype.onScrollStart = function () {
        //this.i.notifyScrollStart();
    };
    IgrListPanel.prototype.onScrollStop = function () {
        //this.i.notifyScrollStop();
    };
    IgrListPanel.prototype.scrollTo = function (x, y) {
        this._scroller.scrollTo(x, y);
        //let width = this._scroller.viewportWidth;
        //let height = this._scroller.viewportHeight;
        //this._grid.setViewport(x, y, x + width, y + height);
    };
    IgrListPanel.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_1, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    IgrListPanel.prototype.initializeProperties = function () {
        var e_2, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    // supports angular themes or custom properties set in CSS
    IgrListPanel.prototype.updateStyle = function () {
        this._styling(this._elRef, this);
    };
    IgrListPanel.prototype.componentWillUnmount = function () {
        if (this._mounted) {
            this._mounted = false;
            if (this.i) {
                if (this._scroller) {
                    this._scroller.onDetachedFromUI();
                }
            }
        }
        this.i.destroy();
        if (this._reactRenderer)
            this._reactRenderer.destroy();
    };
    IgrListPanel.prototype.componentDidMount = function () {
        if (!this._mounted) {
            this._mounted = true;
            if (this.i) {
                if (this._scroller) {
                    this._scroller.onAttachedToUI();
                }
            }
        }
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this.notifySizeChanged();
        this.initializeContent();
    };
    IgrListPanel.prototype.notifySizeChanged = function () {
        if (this._reactRenderer) {
            var width = this._reactRenderer.rootWrapper.width();
            var height = this._reactRenderer.rootWrapper.height();
            this._scroller.viewportWidth = width;
            this._scroller.viewportHeight = height;
            this._scroller.onViewportSizeChanged(width, height, true);
        }
        this.i.notifySizeChanged();
    };
    IgrListPanel.prototype.initializeContent = function () {
        this._styling(this._elRef, this);
        this.updateStyle();
        this.notifySizeChanged();
    };
    IgrListPanel.prototype.createImplementation = function () {
        return new ListPanel();
    };
    Object.defineProperty(IgrListPanel.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "selectionMode", {
        /**
     * Sets or gets the grid selection mode.
    */
        get: function () {
            return this.i.aq;
        },
        set: function (v) {
            this.i.aq = ensureEnum(ListPanelSelectionMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "isActiveRowStyleEnabled", {
        /**
         * Gets or sets whether the active row style will be applied to rows when made active.
        */
        get: function () {
            return this.i.bv;
        },
        set: function (v) {
            this.i.bv = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "selectedBackground", {
        /**
         * Gets or sets the background color to use for the cells when they are selected
        */
        get: function () {
            return brushToString(this.i.hz);
        },
        set: function (v) {
            this.i.hz = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "normalBackground", {
        /**
         * Gets or sets the background color to use.
        */
        get: function () {
            return brushToString(this.i.hx);
        },
        set: function (v) {
            this.i.hx = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "activationBorder", {
        /**
         * Gets or sets the activation border color to use.
        */
        get: function () {
            return brushToString(this.i.ht);
        },
        set: function (v) {
            this.i.ht = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "activationBorderLeftWidth", {
        /**
         * Gets or sets the amount of left activation border to use for the cell content for this column.
        */
        get: function () {
            return this.i.dn;
        },
        set: function (v) {
            this.i.dn = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "activationBorderTopWidth", {
        /**
         * Gets or sets the amount of top activation border to use for the cell content for this column.
        */
        get: function () {
            return this.i.dq;
        },
        set: function (v) {
            this.i.dq = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "activationBorderRightWidth", {
        /**
         * Gets or sets the amount of right activation border to use for the cell content of this column.
        */
        get: function () {
            return this.i.dp;
        },
        set: function (v) {
            this.i.dp = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "activationBorderBottomWidth", {
        /**
         * Gets or sets the amount of bottom activation border to use for the cell content of this column.
        */
        get: function () {
            return this.i.dm;
        },
        set: function (v) {
            this.i.dm = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "activationMode", {
        /**
         * Sets or gets the grid selection mode.
        */
        get: function () {
            return this.i.r;
        },
        set: function (v) {
            this.i.r = ensureEnum(ListPanelActivationMode_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "selectionBehavior", {
        /**
         * Sets or gets how selection behaves in the grid.
        */
        get: function () {
            return this.i.al;
        },
        set: function (v) {
            this.i.al = ensureEnum(ListPanelSelectionBehavior_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "primaryKey", {
        /**
         * Sets or gets the user provided primary key to assume for the data. Certain functionality of the grid requires a way to uniquely identify items in order to work correctly.
         * If a primary key cannot be inferred from the data source, you may need to provide one here.
        */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.f = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "actualPrimaryKey", {
        /**
         * Gets either the inferred primary key from the data source, or the user provided primary key, if present. Represents the actual primary key that the grid will use in operations that require it.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.d = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "selectedItems", {
        /**
         * Gets which items are currently selected in the grid. Collection can be updated to programatically select items.
        */
        get: function () {
            if (this._selectedItems === null) {
                var coll = new IgrListPanelSelectedItemsCollection();
                var innerColl = this.i.ag;
                if (!innerColl) {
                    innerColl = new ListPanelSelectedItemsCollection_internal();
                }
                this._selectedItems = coll._fromInner(innerColl);
            }
            return this._selectedItems;
        },
        set: function (v) {
            if (this._selectedItems !== null) {
                this._selectedItems._setSyncTarget(null);
                this._selectedItems = null;
            }
            var coll = new IgrListPanelSelectedItemsCollection();
            this._selectedItems = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(Base.$type);
            var innerColl = this.i.ag;
            if (!innerColl) {
                innerColl = new ListPanelSelectedItemsCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._selectedItems._setSyncTarget(syncColl);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "selectedKeys", {
        /**
         * Gets which primary key values are currently selected in the grid. Collection can be updated to programatically select items.
        */
        get: function () {
            if (this._selectedKeys === null) {
                var coll = new IgrListPanelSelectedKeysCollection();
                var innerColl = this.i.aj;
                if (!innerColl) {
                    innerColl = new ListPanelSelectedKeysCollection_internal();
                }
                this._selectedKeys = coll._fromInner(innerColl);
            }
            return this._selectedKeys;
        },
        set: function (v) {
            if (this._selectedKeys !== null) {
                this._selectedKeys._setSyncTarget(null);
                this._selectedKeys = null;
            }
            var coll = new IgrListPanelSelectedKeysCollection();
            this._selectedKeys = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(ListPanelPrimaryKeyValue.$type);
            var innerColl = this.i.aj;
            if (!innerColl) {
                innerColl = new ListPanelSelectedKeysCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._selectedKeys._setSyncTarget(syncColl);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "schemaIncludedProperties", {
        /**
         * Gets either the filtered properties to include in the schema of the data source.
        */
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.g = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "rowHeight", {
        /**
         * Gets or Sets the property name that contains the values.
        */
        get: function () {
            return this.i.ea;
        },
        set: function (v) {
            this.i.ea = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "actualRowHeight", {
        get: function () {
            return this.i.c2;
        },
        set: function (v) {
            this.i.c2 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "cellTextStyle", {
        /**
         * Gets or Sets the property name that contains the values.
        */
        get: function () {
            if (this.i.a2 == null) {
                return null;
            }
            return this.i.a2.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.a2 = fi;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "hasUnevenSizes", {
        get: function () {
            return this.i.bt;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "scrollbarStyle", {
        /**
         * Gets or sets the style of scrollbar.
        */
        get: function () {
            return this.i.ay;
        },
        set: function (v) {
            this.i.ay = ensureEnum(ScrollbarStyle_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "scrollbarBackground", {
        /**
         * Gets or sets the scrollbar background color.
        */
        get: function () {
            return brushToString(this.i.hy);
        },
        set: function (v) {
            this.i.hy = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "backgroundColor", {
        /**
         * Gets or sets the color to use for the background of the component.
        */
        get: function () {
            return brushToString(this.i.hu);
        },
        set: function (v) {
            this.i.hu = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "orientation", {
        /**
         * Gets or sets the color to use for the background of the component.
        */
        get: function () {
            return this.i.ab;
        },
        set: function (v) {
            this.i.ab = ensureEnum(ListPanelOrientation_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "isCustomRowHeightEnabled", {
        /**
         * Gets or sets the color to use for the background of the component.
        */
        get: function () {
            return this.i.bx;
        },
        set: function (v) {
            this.i.bx = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "textColor", {
        /**
         * Gets or sets the color to use for the text of the component.
        */
        get: function () {
            return brushToString(this.i.h0);
        },
        set: function (v) {
            this.i.h0 = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "activeRow", {
        /**
         * Gets or sets the position of the active row.
        */
        get: function () {
            return this.i.dr;
        },
        set: function (v) {
            this.i.dr = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "notifyOnAllSelectionChanges", {
        /**
         * Gets or sets if the grid should notify on programmatic selection changes as well as changes from the UI.
        */
        get: function () {
            return this.i.b0;
        },
        set: function (v) {
            this.i.b0 = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrListPanel.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.selectedKeys != null && this.selectedKeys.findByName && this.selectedKeys.findByName(name)) {
            return this.selectedKeys.findByName(name);
        }
        return null;
    };
    Object.defineProperty(IgrListPanel.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgrListPanel.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrListPanel.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ListPanel");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgrListPanel.prototype.getRowKey = function (primaryKey, rowIndex) {
        var iv = this.i.ad(primaryKey, rowIndex);
        var ret = null;
        if (iv && iv.externalObject) {
            ret = iv.externalObject;
        }
        else {
            if (iv) {
                var e = new IgrListPanelPrimaryKeyValue();
                e._implementation = iv;
                iv.externalObject = e;
                ret = e;
            }
        }
        return ret;
    };
    IgrListPanel.prototype.getItemKey = function (primaryKey, item_) {
        var iv = this.i.ac(primaryKey, item_);
        var ret = null;
        if (iv && iv.externalObject) {
            ret = iv.externalObject;
        }
        else {
            if (iv) {
                var e = new IgrListPanelPrimaryKeyValue();
                e._implementation = iv;
                iv.externalObject = e;
                ret = e;
            }
        }
        return ret;
    };
    /**
     * Gets the last visible index in the grid.
    
    */
    IgrListPanel.prototype.getLastVisibleIndex = function () {
        var iv = this.i.d0();
        return (iv);
    };
    /**
     * Gets the first visible index in the grid.
    
    */
    IgrListPanel.prototype.getFirstVisibleIndex = function () {
        var iv = this.i.dy();
        return (iv);
    };
    /**
     * Invalidates the bound data for the rows currently visible.
    
    */
    IgrListPanel.prototype.invalidateVisibleItems = function () {
        this.i.f0();
    };
    IgrListPanel.prototype.notifySetItem = function (index, oldItem, newItem) {
        this.i.f6(index, oldItem, newItem);
    };
    /**
     * Manually notifies the grid's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the grid is bound to is already observable.
    
    */
    IgrListPanel.prototype.notifyClearItems = function () {
        this.i.f3();
    };
    IgrListPanel.prototype.notifyInsertItem = function (index, newItem) {
        this.i.f4(index, newItem);
    };
    IgrListPanel.prototype.notifyRemoveItem = function (index, oldItem) {
        this.i.f5(index, oldItem);
    };
    /**
     * Returns the data index of an item within the bound data source.
    
    * @param item  * The item from which to get the index.
    */
    IgrListPanel.prototype.dataIndexOfItem = function (item) {
        var iv = this.i.dt(item);
        return (iv);
    };
    IgrListPanel.prototype.dataIndexOfPrimaryKey = function (key) {
        var iv = this.i.du(key);
        return (iv);
    };
    IgrListPanel.prototype.exportVisualData = function () {
        var iv = this.i.ed();
        return (iv);
    };
    IgrListPanel.prototype.exportSerializedVisualData = function () {
        var iv = this.i.ev();
        return (iv);
    };
    /**
     * Selects all of the rows in the grid.
    
    */
    IgrListPanel.prototype.selectAllRows = function () {
        this.i.hc();
    };
    /**
     * Scrolls the grid to given row, by index
    
    * @param rowNumber  * The row index to scroll to.
    */
    IgrListPanel.prototype.scrollToRowByIndex = function (rowNumber) {
        this.i.ha(rowNumber);
    };
    /**
     * Scrolls the grid so that a row is the last visible, by index.
    
    * @param rowNumber  * The row index to scroll to.
    */
    IgrListPanel.prototype.scrollToLastRowByIndex = function (rowNumber) {
        this.i.g8(rowNumber);
    };
    /**
     * Deselects all currently selected rows.
    
    */
    IgrListPanel.prototype.deselectAllRows = function () {
        this.i.fk();
    };
    Object.defineProperty(IgrListPanel.prototype, "selectedItemsChanged", {
        /**
         * Called when the selected items change.
        */
        get: function () {
            return this._selectedItemsChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._selectedItemsChanged_wrapped !== null) {
                this.i.selectedItemsChanged = delegateRemove(this.i.selectedItemsChanged, this._selectedItemsChanged_wrapped);
                this._selectedItemsChanged_wrapped = null;
                this._selectedItemsChanged = null;
            }
            this._selectedItemsChanged = ev;
            this._selectedItemsChanged_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelSelectedItemsChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSelectedItemsChanged) {
                    _this.beforeSelectedItemsChanged(_this, outerArgs);
                }
                if (_this._selectedItemsChanged) {
                    _this._selectedItemsChanged(_this, outerArgs);
                }
            };
            this.i.selectedItemsChanged = delegateCombine(this.i.selectedItemsChanged, this._selectedItemsChanged_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "selectedKeysChanged", {
        /**
         * Called when the selected keys change.
        */
        get: function () {
            return this._selectedKeysChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._selectedKeysChanged_wrapped !== null) {
                this.i.selectedKeysChanged = delegateRemove(this.i.selectedKeysChanged, this._selectedKeysChanged_wrapped);
                this._selectedKeysChanged_wrapped = null;
                this._selectedKeysChanged = null;
            }
            this._selectedKeysChanged = ev;
            this._selectedKeysChanged_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelSelectedKeysChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSelectedKeysChanged) {
                    _this.beforeSelectedKeysChanged(_this, outerArgs);
                }
                if (_this._selectedKeysChanged) {
                    _this._selectedKeysChanged(_this, outerArgs);
                }
            };
            this.i.selectedKeysChanged = delegateCombine(this.i.selectedKeysChanged, this._selectedKeysChanged_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "selectionChanged", {
        /**
         * Called when an individual selection operation has been made.
        */
        get: function () {
            return this._selectionChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._selectionChanged_wrapped !== null) {
                this.i.selectionChanged = delegateRemove(this.i.selectionChanged, this._selectionChanged_wrapped);
                this._selectionChanged_wrapped = null;
                this._selectionChanged = null;
            }
            this._selectionChanged = ev;
            this._selectionChanged_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelSelectionChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSelectionChanged) {
                    _this.beforeSelectionChanged(_this, outerArgs);
                }
                if (_this._selectionChanged) {
                    _this._selectionChanged(_this, outerArgs);
                }
            };
            this.i.selectionChanged = delegateCombine(this.i.selectionChanged, this._selectionChanged_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "activeRowChanged", {
        /**
         * Called when the active row changes.
        */
        get: function () {
            return this._activeRowChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._activeRowChanged_wrapped !== null) {
                this.i.activeRowChanged = delegateRemove(this.i.activeRowChanged, this._activeRowChanged_wrapped);
                this._activeRowChanged_wrapped = null;
                this._activeRowChanged = null;
            }
            this._activeRowChanged = ev;
            this._activeRowChanged_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelActiveRowChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeActiveRowChanged) {
                    _this.beforeActiveRowChanged(_this, outerArgs);
                }
                if (_this._activeRowChanged) {
                    _this._activeRowChanged(_this, outerArgs);
                }
            };
            this.i.activeRowChanged = delegateCombine(this.i.activeRowChanged, this._activeRowChanged_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "contentRefreshed", {
        get: function () {
            return this._contentRefreshed;
        },
        set: function (ev) {
            var _this = this;
            if (this._contentRefreshed_wrapped !== null) {
                this.i.contentRefreshed = delegateRemove(this.i.contentRefreshed, this._contentRefreshed_wrapped);
                this._contentRefreshed_wrapped = null;
                this._contentRefreshed = null;
            }
            this._contentRefreshed = ev;
            this._contentRefreshed_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelContentRefreshedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeContentRefreshed) {
                    _this.beforeContentRefreshed(_this, outerArgs);
                }
                if (_this._contentRefreshed) {
                    _this._contentRefreshed(_this, outerArgs);
                }
            };
            this.i.contentRefreshed = delegateCombine(this.i.contentRefreshed, this._contentRefreshed_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "rowUpdating", {
        get: function () {
            return this._rowUpdating;
        },
        set: function (ev) {
            var _this = this;
            if (this._rowUpdating_wrapped !== null) {
                this.i.rowUpdating = delegateRemove(this.i.rowUpdating, this._rowUpdating_wrapped);
                this._rowUpdating_wrapped = null;
                this._rowUpdating = null;
            }
            this._rowUpdating = ev;
            this._rowUpdating_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelTemplateItemUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeRowUpdating) {
                    _this.beforeRowUpdating(_this, outerArgs);
                }
                if (_this._rowUpdating) {
                    _this._rowUpdating(_this, outerArgs);
                }
            };
            this.i.rowUpdating = delegateCombine(this.i.rowUpdating, this._rowUpdating_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "itemWidthRequested", {
        get: function () {
            return this._itemWidthRequested;
        },
        set: function (ev) {
            var _this = this;
            if (this._itemWidthRequested_wrapped !== null) {
                this.i.itemWidthRequested = delegateRemove(this.i.itemWidthRequested, this._itemWidthRequested_wrapped);
                this._itemWidthRequested_wrapped = null;
                this._itemWidthRequested = null;
            }
            this._itemWidthRequested = ev;
            this._itemWidthRequested_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelTemplateWidthRequestedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeItemWidthRequested) {
                    _this.beforeItemWidthRequested(_this, outerArgs);
                }
                if (_this._itemWidthRequested) {
                    _this._itemWidthRequested(_this, outerArgs);
                }
            };
            this.i.itemWidthRequested = delegateCombine(this.i.itemWidthRequested, this._itemWidthRequested_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "itemHeightRequested", {
        get: function () {
            return this._itemHeightRequested;
        },
        set: function (ev) {
            var _this = this;
            if (this._itemHeightRequested_wrapped !== null) {
                this.i.itemHeightRequested = delegateRemove(this.i.itemHeightRequested, this._itemHeightRequested_wrapped);
                this._itemHeightRequested_wrapped = null;
                this._itemHeightRequested = null;
            }
            this._itemHeightRequested = ev;
            this._itemHeightRequested_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelTemplateHeightRequestedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeItemHeightRequested) {
                    _this.beforeItemHeightRequested(_this, outerArgs);
                }
                if (_this._itemHeightRequested) {
                    _this._itemHeightRequested(_this, outerArgs);
                }
            };
            this.i.itemHeightRequested = delegateCombine(this.i.itemHeightRequested, this._itemHeightRequested_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "itemClicked", {
        get: function () {
            return this._itemClicked;
        },
        set: function (ev) {
            var _this = this;
            if (this._itemClicked_wrapped !== null) {
                this.i.itemClicked = delegateRemove(this.i.itemClicked, this._itemClicked_wrapped);
                this._itemClicked_wrapped = null;
                this._itemClicked = null;
            }
            this._itemClicked = ev;
            this._itemClicked_wrapped = function (o, e) {
                var outerArgs = new IgrListPanelItemEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeItemClicked) {
                    _this.beforeItemClicked(_this, outerArgs);
                }
                if (_this._itemClicked) {
                    _this._itemClicked(_this, outerArgs);
                }
            };
            this.i.itemClicked = delegateCombine(this.i.itemClicked, this._itemClicked_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanel.prototype, "actualPrimaryKeyChange", {
        get: function () {
            return this._actualPrimaryKeyChange;
        },
        set: function (ev) {
            var _this = this;
            if (this._actualPrimaryKeyChange_wrapped !== null) {
                this.i.propertyChanged = delegateRemove(this.i.propertyChanged, this._actualPrimaryKeyChange_wrapped);
                this._actualPrimaryKeyChange_wrapped = null;
                this._actualPrimaryKeyChange = null;
            }
            this._actualPrimaryKeyChange = ev;
            this._actualPrimaryKeyChange_wrapped = function (o, e) {
                var ext = _this.actualPrimaryKey;
                if (_this.beforeActualPrimaryKeyChange) {
                    _this.beforeActualPrimaryKeyChange(_this, ext);
                }
                if (_this._actualPrimaryKeyChange) {
                    _this._actualPrimaryKeyChange(_this, ext);
                }
            };
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, this._actualPrimaryKeyChange_wrapped);
        },
        enumerable: false,
        configurable: true
    });
    return IgrListPanel;
}(React.Component));
export { IgrListPanel };
