import { __extends } from "tslib";
import { ToolActionButtonGroupDisplayType_$type } from "./ToolActionButtonGroupDisplayType";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionButtonPair } from "./ToolActionButtonPair";
import { ensureBool, brushToString, stringToBrush, toBrushCollection, fromBrushCollection, ensureEnum } from "igniteui-react-core";
var IgrToolActionButtonPair = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrToolActionButtonPair, _super);
    function IgrToolActionButtonPair(props) {
        return _super.call(this, props) || this;
    }
    IgrToolActionButtonPair.prototype.createImplementation = function () {
        return new ToolActionButtonPair();
    };
    Object.defineProperty(IgrToolActionButtonPair.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIsSelected", {
        get: function () {
            return this.i.hs;
        },
        set: function (v) {
            this.i.hs = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIsSelected", {
        get: function () {
            return this.i.hv;
        },
        set: function (v) {
            this.i.hv = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIsDisabled", {
        get: function () {
            return this.i.hr;
        },
        set: function (v) {
            this.i.hr = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIsDisabled", {
        get: function () {
            return this.i.hu;
        },
        set: function (v) {
            this.i.hu = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIconName", {
        get: function () {
            return this.i.io;
        },
        set: function (v) {
            this.i.io = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftCommandArgument", {
        get: function () {
            return this.i.ih;
        },
        set: function (v) {
            this.i.ih = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "isToggleDisabled", {
        get: function () {
            return this.i.hq;
        },
        set: function (v) {
            this.i.hq = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIconCollectionName", {
        get: function () {
            return this.i.ij;
        },
        set: function (v) {
            this.i.ij = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIconViewBoxLeft", {
        /**
         * Gets or sets the LeftIcon viewbox left.
        */
        get: function () {
            return this.i.h1;
        },
        set: function (v) {
            this.i.h1 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIconViewBoxTop", {
        /**
         * Gets or sets the LeftIcon viewbox top.
        */
        get: function () {
            return this.i.h2;
        },
        set: function (v) {
            this.i.h2 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIconViewBoxWidth", {
        /**
         * Gets or sets the LeftIcon viewbox width.
        */
        get: function () {
            return this.i.h3;
        },
        set: function (v) {
            this.i.h3 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIconViewBoxHeight", {
        /**
         * Gets or sets the LeftIcon viewbox height.
        */
        get: function () {
            return this.i.h0;
        },
        set: function (v) {
            this.i.h0 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIconFill", {
        /**
         * Gets or sets the LeftIcon fill color.
        */
        get: function () {
            return brushToString(this.i.jr);
        },
        set: function (v) {
            this.i.jr = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "actualLeftIconFill", {
        /**
         * Gets the actual LeftIcon fill color.
        */
        get: function () {
            return brushToString(this.i.jn);
        },
        set: function (v) {
            this.i.jn = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIconFillColors", {
        /**
         * Gets or sets the LeftIcon fill colors.
        */
        get: function () {
            return fromBrushCollection(this.i.g7);
        },
        set: function (v) {
            this.i.g7 = toBrushCollection(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIconStroke", {
        /**
         * Gets or sets the LeftIcon stroke color.
        */
        get: function () {
            return brushToString(this.i.js);
        },
        set: function (v) {
            this.i.js = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "actualLeftIconStroke", {
        /**
         * Gets the actual LeftIcon stroke color.
        */
        get: function () {
            return brushToString(this.i.jo);
        },
        set: function (v) {
            this.i.jo = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIconStrokeColors", {
        /**
         * Gets or sets the LeftIcon stroke colors.
        */
        get: function () {
            return fromBrushCollection(this.i.g8);
        },
        set: function (v) {
            this.i.g8 = toBrushCollection(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftIconStrokeWidth", {
        /**
         * Gets or sets the LeftIcon viewbox width.
        */
        get: function () {
            return this.i.hz;
        },
        set: function (v) {
            this.i.hz = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "leftTitle", {
        /**
         * Gets or sets the title of the left button.
        */
        get: function () {
            return this.i.iz;
        },
        set: function (v) {
            this.i.iz = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIconName", {
        get: function () {
            return this.i.i7;
        },
        set: function (v) {
            this.i.i7 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightCommandArgument", {
        get: function () {
            return this.i.i1;
        },
        set: function (v) {
            this.i.i1 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIconCollectionName", {
        get: function () {
            return this.i.i3;
        },
        set: function (v) {
            this.i.i3 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIconViewBoxLeft", {
        /**
         * Gets or sets the RightIcon viewbox left.
        */
        get: function () {
            return this.i.h6;
        },
        set: function (v) {
            this.i.h6 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIconViewBoxTop", {
        /**
         * Gets or sets the RightIcon viewbox top.
        */
        get: function () {
            return this.i.h7;
        },
        set: function (v) {
            this.i.h7 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIconViewBoxWidth", {
        /**
         * Gets or sets the RightIcon viewbox width.
        */
        get: function () {
            return this.i.h8;
        },
        set: function (v) {
            this.i.h8 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIconViewBoxHeight", {
        /**
         * Gets or sets the RightIcon viewbox height.
        */
        get: function () {
            return this.i.h5;
        },
        set: function (v) {
            this.i.h5 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIconFill", {
        /**
         * Gets or sets the RightIcon fill color.
        */
        get: function () {
            return brushToString(this.i.jt);
        },
        set: function (v) {
            this.i.jt = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "actualRightIconFill", {
        /**
         * Gets the actual RightIcon fill color.
        */
        get: function () {
            return brushToString(this.i.jp);
        },
        set: function (v) {
            this.i.jp = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIconFillColors", {
        /**
         * Gets or sets the RightIcon fill colors.
        */
        get: function () {
            return fromBrushCollection(this.i.g9);
        },
        set: function (v) {
            this.i.g9 = toBrushCollection(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIconStroke", {
        /**
         * Gets or sets the RightIcon stroke color.
        */
        get: function () {
            return brushToString(this.i.ju);
        },
        set: function (v) {
            this.i.ju = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "actualRightIconStroke", {
        /**
         * Gets the actual RightIcon stroke color.
        */
        get: function () {
            return brushToString(this.i.jq);
        },
        set: function (v) {
            this.i.jq = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIconStrokeColors", {
        /**
         * Gets or sets the RightIcon stroke colors.
        */
        get: function () {
            return fromBrushCollection(this.i.ha);
        },
        set: function (v) {
            this.i.ha = toBrushCollection(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightIconStrokeWidth", {
        /**
         * Gets or sets the RightIcon viewbox width.
        */
        get: function () {
            return this.i.h4;
        },
        set: function (v) {
            this.i.h4 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "rightTitle", {
        /**
         * Gets or sets the title of the Right button.
        */
        get: function () {
            return this.i.ji;
        },
        set: function (v) {
            this.i.ji = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "displayType", {
        /**
         * Gets or sets the display type for the button.
        */
        get: function () {
            return this.i.hb;
        },
        set: function (v) {
            this.i.hb = ensureEnum(ToolActionButtonGroupDisplayType_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionButtonPair.prototype, "cornerRadius", {
        /**
         * Gets or sets the button corner radius.
        */
        get: function () {
            return this.i.hw;
        },
        set: function (v) {
            this.i.hw = +v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrToolActionButtonPair;
}(IgrToolAction));
export { IgrToolActionButtonPair };
