import { __extends } from "tslib";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionCheckbox } from "./ToolActionCheckbox";
import { ensureBool, brushToString, stringToBrush } from "igniteui-react-core";
var IgrToolActionCheckbox = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrToolActionCheckbox, _super);
    function IgrToolActionCheckbox(props) {
        return _super.call(this, props) || this;
    }
    IgrToolActionCheckbox.prototype.createImplementation = function () {
        return new ToolActionCheckbox();
    };
    Object.defineProperty(IgrToolActionCheckbox.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCheckbox.prototype, "isChecked", {
        /**
         * Gets or sets if the tool action is checked.
        */
        get: function () {
            return this.i.g6;
        },
        set: function (v) {
            this.i.g6 = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCheckbox.prototype, "uncheckedBackgroundColor", {
        /**
         * Gets or sets the background color of the checkbox when in the unchecked state.
        */
        get: function () {
            return brushToString(this.i.ho);
        },
        set: function (v) {
            this.i.ho = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCheckbox.prototype, "actualUncheckedBackgroundColor", {
        /**
         * Gets the actual background color of the checkbox when in the unchecked state.
        */
        get: function () {
            return brushToString(this.i.hk);
        },
        set: function (v) {
            this.i.hk = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCheckbox.prototype, "checkedBackgroundColor", {
        /**
         * Gets or sets the background color of the checkbox when in the checked state.
        */
        get: function () {
            return brushToString(this.i.hm);
        },
        set: function (v) {
            this.i.hm = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCheckbox.prototype, "actualCheckedBackgroundColor", {
        /**
         * Gets the actual background color of the checkbox when in the checked state.
        */
        get: function () {
            return brushToString(this.i.hi);
        },
        set: function (v) {
            this.i.hi = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCheckbox.prototype, "uncheckedBorderColor", {
        /**
         * Gets or sets the border color of the checkbox when in the unchecked state.
        */
        get: function () {
            return brushToString(this.i.hp);
        },
        set: function (v) {
            this.i.hp = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCheckbox.prototype, "actualUncheckedBorderColor", {
        /**
         * Gets the actual border color of the checkbox when in the unchecked state.
        */
        get: function () {
            return brushToString(this.i.hl);
        },
        set: function (v) {
            this.i.hl = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCheckbox.prototype, "checkedBorderColor", {
        /**
         * Gets or sets the border color of the checkbox when in the checked state.
        */
        get: function () {
            return brushToString(this.i.hn);
        },
        set: function (v) {
            this.i.hn = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCheckbox.prototype, "actualCheckedBorderColor", {
        /**
         * Gets the actual border color of the checkbox when in the checked state.
        */
        get: function () {
            return brushToString(this.i.hj);
        },
        set: function (v) {
            this.i.hj = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrToolActionCheckbox;
}(IgrToolAction));
export { IgrToolActionCheckbox };
