import { __extends } from "tslib";
import { IgrLayoutSelectedItemsCollection } from "./igr-layout-selected-items-collection";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionCombo } from "./ToolActionCombo";
import { LayoutSelectedItemsCollection as LayoutSelectedItemsCollection_internal } from "./LayoutSelectedItemsCollection";
import { Base } from "igniteui-react-core";
import { SyncableObservableCollection$1 } from "igniteui-react-core";
var IgrToolActionCombo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrToolActionCombo, _super);
    function IgrToolActionCombo(props) {
        var _this = _super.call(this, props) || this;
        _this._selectedValues = null;
        return _this;
    }
    IgrToolActionCombo.prototype.createImplementation = function () {
        return new ToolActionCombo();
    };
    Object.defineProperty(IgrToolActionCombo.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCombo.prototype, "dataSource", {
        /**
         * Gets or sets if the tool action is checked.
        */
        get: function () {
            return this.i.itemsSource;
        },
        set: function (v) {
            this.i.itemsSource = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCombo.prototype, "displayMemberPath", {
        /**
         * Gets or sets the field to use to get the displayed values.
        */
        get: function () {
            return this.i.g9;
        },
        set: function (v) {
            this.i.g9 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCombo.prototype, "valueMemberPath", {
        /**
         * Gets or sets the field to use to get the values to use.
        */
        get: function () {
            return this.i.hd;
        },
        set: function (v) {
            this.i.hd = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionCombo.prototype, "selectedValues", {
        /**
        
        */
        get: function () {
            if (this._selectedValues === null) {
                var coll = new IgrLayoutSelectedItemsCollection();
                var innerColl = this.i.g5;
                if (!innerColl) {
                    innerColl = new LayoutSelectedItemsCollection_internal();
                }
                this._selectedValues = coll._fromInner(innerColl);
                this.i.g5 = innerColl;
            }
            return this._selectedValues;
        },
        set: function (v) {
            if (this._selectedValues !== null) {
                this._selectedValues._setSyncTarget(null);
                this._selectedValues = null;
            }
            var coll = new IgrLayoutSelectedItemsCollection();
            this._selectedValues = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(Base.$type);
            var innerColl = this.i.g5;
            if (!innerColl) {
                innerColl = new LayoutSelectedItemsCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._selectedValues._setSyncTarget(syncColl);
            this.i.g5 = innerColl;
        },
        enumerable: false,
        configurable: true
    });
    return IgrToolActionCombo;
}(IgrToolAction));
export { IgrToolActionCombo };
