import * as React from 'react';
import { ListPanel } from './ListPanel';
import { IDataSource } from "igniteui-react-core";
import { IgrListPanelTemplateItemUpdatingEventArgs } from './igr-list-panel-template-item-updating-event-args';
import { ListPanelOrientation } from './ListPanelOrientation';
import { IgrListPanelContentRefreshedEventArgs } from './igr-list-panel-content-refreshed-event-args';
import { IgrListPanelTemplateWidthRequestedEventArgs } from './igr-list-panel-template-width-requested-event-args';
import { IgrListPanelTemplateHeightRequestedEventArgs } from './igr-list-panel-template-height-requested-event-args';
import { IExternalListPanel } from './IExternalListPanel';
import { ScrollbarStyle } from "igniteui-react-core";
import { IgrListPanelItemEventArgs } from './igr-list-panel-item-event-args';
import { IgrListPanelActiveRowChangedEventArgs } from './igr-list-panel-active-row-changed-event-args';
import { IgrListPanelSelectionChangedEventArgs } from './igr-list-panel-selection-changed-event-args';
import { IgrListPanelSelectedKeysChangedEventArgs } from './igr-list-panel-selected-keys-changed-event-args';
import { IgrListPanelSelectedItemsChangedEventArgs } from './igr-list-panel-selected-items-changed-event-args';
import { IgrListPanelPrimaryKeyValue } from './igr-list-panel-primary-key-value';
import { IgrListPanelSelectedKeysCollection } from './igr-list-panel-selected-keys-collection';
import { ListPanelSelectionMode } from './ListPanelSelectionMode';
import { ListPanelActivationMode } from './ListPanelActivationMode';
import { ListPanelSelectionBehavior } from './ListPanelSelectionBehavior';
import { IgrListPanelSelectedItemsCollection } from './igr-list-panel-selected-items-collection';
export declare class IgrListPanel extends React.Component<IIgrListPanelProps> implements IExternalListPanel {
    private _implementation;
    private _reactRenderer;
    private _height;
    private _width;
    private _initialized;
    private _elRef;
    private _portalManager;
    private _scroller;
    setScrollbarStyle(style: ScrollbarStyle): void;
    setScrollbarColor(color: any): void;
    createLocalDataSource(itemsSource: any, schemaIncludedProperties: string[]): IDataSource;
    onContentSizeChanged(): void;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private ensureStretch;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        ref: (ref: any) => void;
        className: string;
    }, any>;
    moveViewportTo(x: number, y: number): void;
    private _content;
    private verifyReferences;
    onScroll(): void;
    onScrollStart(): void;
    onScrollStop(): void;
    scrollTo(x: number, y: number): void;
    constructor(props: IIgrListPanelProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    componentWillUnmount(): void;
    private _mounted;
    componentDidMount(): void;
    notifySizeChanged(): void;
    initializeContent(): void;
    protected createImplementation(): ListPanel;
    get i(): ListPanel;
    /**
 * Sets or gets the grid selection mode.
*/
    get selectionMode(): ListPanelSelectionMode;
    set selectionMode(v: ListPanelSelectionMode);
    /**
     * Gets or sets whether the active row style will be applied to rows when made active.
    */
    get isActiveRowStyleEnabled(): boolean;
    set isActiveRowStyleEnabled(v: boolean);
    /**
     * Gets or sets the background color to use for the cells when they are selected
    */
    get selectedBackground(): string;
    set selectedBackground(v: string);
    /**
     * Gets or sets the background color to use.
    */
    get normalBackground(): string;
    set normalBackground(v: string);
    /**
     * Gets or sets the activation border color to use.
    */
    get activationBorder(): string;
    set activationBorder(v: string);
    /**
     * Gets or sets the amount of left activation border to use for the cell content for this column.
    */
    get activationBorderLeftWidth(): number;
    set activationBorderLeftWidth(v: number);
    /**
     * Gets or sets the amount of top activation border to use for the cell content for this column.
    */
    get activationBorderTopWidth(): number;
    set activationBorderTopWidth(v: number);
    /**
     * Gets or sets the amount of right activation border to use for the cell content of this column.
    */
    get activationBorderRightWidth(): number;
    set activationBorderRightWidth(v: number);
    /**
     * Gets or sets the amount of bottom activation border to use for the cell content of this column.
    */
    get activationBorderBottomWidth(): number;
    set activationBorderBottomWidth(v: number);
    /**
     * Sets or gets the grid selection mode.
    */
    get activationMode(): ListPanelActivationMode;
    set activationMode(v: ListPanelActivationMode);
    /**
     * Sets or gets how selection behaves in the grid.
    */
    get selectionBehavior(): ListPanelSelectionBehavior;
    set selectionBehavior(v: ListPanelSelectionBehavior);
    /**
     * Sets or gets the user provided primary key to assume for the data. Certain functionality of the grid requires a way to uniquely identify items in order to work correctly.
     * If a primary key cannot be inferred from the data source, you may need to provide one here.
    */
    get primaryKey(): string[];
    set primaryKey(v: string[]);
    /**
     * Gets either the inferred primary key from the data source, or the user provided primary key, if present. Represents the actual primary key that the grid will use in operations that require it.
    */
    get actualPrimaryKey(): string[];
    set actualPrimaryKey(v: string[]);
    private _selectedItems;
    /**
     * Gets which items are currently selected in the grid. Collection can be updated to programatically select items.
    */
    get selectedItems(): IgrListPanelSelectedItemsCollection;
    set selectedItems(v: IgrListPanelSelectedItemsCollection);
    private _selectedKeys;
    /**
     * Gets which primary key values are currently selected in the grid. Collection can be updated to programatically select items.
    */
    get selectedKeys(): IgrListPanelSelectedKeysCollection;
    set selectedKeys(v: IgrListPanelSelectedKeysCollection);
    /**
     * Gets either the filtered properties to include in the schema of the data source.
    */
    get schemaIncludedProperties(): string[];
    set schemaIncludedProperties(v: string[]);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get rowHeight(): number;
    set rowHeight(v: number);
    get actualRowHeight(): number;
    set actualRowHeight(v: number);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get cellTextStyle(): string;
    set cellTextStyle(v: string);
    get hasUnevenSizes(): boolean;
    /**
     * Gets or sets the style of scrollbar.
    */
    get scrollbarStyle(): ScrollbarStyle;
    set scrollbarStyle(v: ScrollbarStyle);
    /**
     * Gets or sets the scrollbar background color.
    */
    get scrollbarBackground(): string;
    set scrollbarBackground(v: string);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get orientation(): ListPanelOrientation;
    set orientation(v: ListPanelOrientation);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get isCustomRowHeightEnabled(): boolean;
    set isCustomRowHeightEnabled(v: boolean);
    /**
     * Gets or sets the color to use for the text of the component.
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or sets the position of the active row.
    */
    get activeRow(): number;
    set activeRow(v: number);
    /**
     * Gets or sets if the grid should notify on programmatic selection changes as well as changes from the UI.
    */
    get notifyOnAllSelectionChanges(): boolean;
    set notifyOnAllSelectionChanges(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    getRowKey(primaryKey: string[], rowIndex: number): IgrListPanelPrimaryKeyValue;
    getItemKey(primaryKey: string[], item_: any): IgrListPanelPrimaryKeyValue;
    /**
     * Gets the last visible index in the grid.
    
    */
    getLastVisibleIndex(): number;
    /**
     * Gets the first visible index in the grid.
    
    */
    getFirstVisibleIndex(): number;
    /**
     * Invalidates the bound data for the rows currently visible.
    
    */
    invalidateVisibleItems(): void;
    notifySetItem(index: number, oldItem: any, newItem: any): void;
    /**
     * Manually notifies the grid's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the grid is bound to is already observable.
    
    */
    notifyClearItems(): void;
    notifyInsertItem(index: number, newItem: any): void;
    notifyRemoveItem(index: number, oldItem: any): void;
    /**
     * Returns the data index of an item within the bound data source.
    
    * @param item  * The item from which to get the index.
    */
    dataIndexOfItem(item: any): number;
    dataIndexOfPrimaryKey(key: any[]): number;
    exportVisualData(): any;
    exportSerializedVisualData(): string;
    /**
     * Selects all of the rows in the grid.
    
    */
    selectAllRows(): void;
    /**
     * Scrolls the grid to given row, by index
    
    * @param rowNumber  * The row index to scroll to.
    */
    scrollToRowByIndex(rowNumber: number): void;
    /**
     * Scrolls the grid so that a row is the last visible, by index.
    
    * @param rowNumber  * The row index to scroll to.
    */
    scrollToLastRowByIndex(rowNumber: number): void;
    /**
     * Deselects all currently selected rows.
    
    */
    deselectAllRows(): void;
    private _selectedItemsChanged;
    private _selectedItemsChanged_wrapped;
    /**
     * Called when the selected items change.
    */
    get selectedItemsChanged(): (s: IgrListPanel, e: IgrListPanelSelectedItemsChangedEventArgs) => void;
    set selectedItemsChanged(ev: (s: IgrListPanel, e: IgrListPanelSelectedItemsChangedEventArgs) => void);
    private _selectedKeysChanged;
    private _selectedKeysChanged_wrapped;
    /**
     * Called when the selected keys change.
    */
    get selectedKeysChanged(): (s: IgrListPanel, e: IgrListPanelSelectedKeysChangedEventArgs) => void;
    set selectedKeysChanged(ev: (s: IgrListPanel, e: IgrListPanelSelectedKeysChangedEventArgs) => void);
    private _selectionChanged;
    private _selectionChanged_wrapped;
    /**
     * Called when an individual selection operation has been made.
    */
    get selectionChanged(): (s: IgrListPanel, e: IgrListPanelSelectionChangedEventArgs) => void;
    set selectionChanged(ev: (s: IgrListPanel, e: IgrListPanelSelectionChangedEventArgs) => void);
    private _activeRowChanged;
    private _activeRowChanged_wrapped;
    /**
     * Called when the active row changes.
    */
    get activeRowChanged(): (s: IgrListPanel, e: IgrListPanelActiveRowChangedEventArgs) => void;
    set activeRowChanged(ev: (s: IgrListPanel, e: IgrListPanelActiveRowChangedEventArgs) => void);
    private _contentRefreshed;
    private _contentRefreshed_wrapped;
    get contentRefreshed(): (s: IgrListPanel, e: IgrListPanelContentRefreshedEventArgs) => void;
    set contentRefreshed(ev: (s: IgrListPanel, e: IgrListPanelContentRefreshedEventArgs) => void);
    private _rowUpdating;
    private _rowUpdating_wrapped;
    get rowUpdating(): (s: IgrListPanel, e: IgrListPanelTemplateItemUpdatingEventArgs) => void;
    set rowUpdating(ev: (s: IgrListPanel, e: IgrListPanelTemplateItemUpdatingEventArgs) => void);
    private _itemWidthRequested;
    private _itemWidthRequested_wrapped;
    get itemWidthRequested(): (s: IgrListPanel, e: IgrListPanelTemplateWidthRequestedEventArgs) => void;
    set itemWidthRequested(ev: (s: IgrListPanel, e: IgrListPanelTemplateWidthRequestedEventArgs) => void);
    private _itemHeightRequested;
    private _itemHeightRequested_wrapped;
    get itemHeightRequested(): (s: IgrListPanel, e: IgrListPanelTemplateHeightRequestedEventArgs) => void;
    set itemHeightRequested(ev: (s: IgrListPanel, e: IgrListPanelTemplateHeightRequestedEventArgs) => void);
    private _itemClicked;
    private _itemClicked_wrapped;
    get itemClicked(): (s: IgrListPanel, e: IgrListPanelItemEventArgs) => void;
    set itemClicked(ev: (s: IgrListPanel, e: IgrListPanelItemEventArgs) => void);
    private _actualPrimaryKeyChange;
    private _actualPrimaryKeyChange_wrapped;
    get actualPrimaryKeyChange(): (s: IgrListPanel, e: string[]) => void;
    set actualPrimaryKeyChange(ev: (s: IgrListPanel, e: string[]) => void);
}
export interface IIgrListPanelProps {
    width?: string;
    height?: string;
    children?: React.ReactNode;
    dataSource?: any;
    /**
 * Sets or gets the grid selection mode.
*/
    selectionMode?: ListPanelSelectionMode | string;
    /**
     * Gets or sets whether the active row style will be applied to rows when made active.
    */
    isActiveRowStyleEnabled?: boolean | string;
    /**
     * Gets or sets the background color to use for the cells when they are selected
    */
    selectedBackground?: string;
    /**
     * Gets or sets the background color to use.
    */
    normalBackground?: string;
    /**
     * Gets or sets the activation border color to use.
    */
    activationBorder?: string;
    /**
     * Gets or sets the amount of left activation border to use for the cell content for this column.
    */
    activationBorderLeftWidth?: number | string;
    /**
     * Gets or sets the amount of top activation border to use for the cell content for this column.
    */
    activationBorderTopWidth?: number | string;
    /**
     * Gets or sets the amount of right activation border to use for the cell content of this column.
    */
    activationBorderRightWidth?: number | string;
    /**
     * Gets or sets the amount of bottom activation border to use for the cell content of this column.
    */
    activationBorderBottomWidth?: number | string;
    /**
     * Sets or gets the grid selection mode.
    */
    activationMode?: ListPanelActivationMode | string;
    /**
     * Sets or gets how selection behaves in the grid.
    */
    selectionBehavior?: ListPanelSelectionBehavior | string;
    /**
     * Sets or gets the user provided primary key to assume for the data. Certain functionality of the grid requires a way to uniquely identify items in order to work correctly.
     * If a primary key cannot be inferred from the data source, you may need to provide one here.
    */
    primaryKey?: string[];
    /**
     * Gets either the inferred primary key from the data source, or the user provided primary key, if present. Represents the actual primary key that the grid will use in operations that require it.
    */
    actualPrimaryKey?: string[];
    /**
     * Gets either the filtered properties to include in the schema of the data source.
    */
    schemaIncludedProperties?: string[];
    /**
     * Gets or Sets the property name that contains the values.
    */
    rowHeight?: number | string;
    actualRowHeight?: number | string;
    /**
     * Gets or Sets the property name that contains the values.
    */
    cellTextStyle?: string;
    /**
     * Gets or sets the style of scrollbar.
    */
    scrollbarStyle?: ScrollbarStyle | string;
    /**
     * Gets or sets the scrollbar background color.
    */
    scrollbarBackground?: string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    backgroundColor?: string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    orientation?: ListPanelOrientation | string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    isCustomRowHeightEnabled?: boolean | string;
    /**
     * Gets or sets the color to use for the text of the component.
    */
    textColor?: string;
    /**
     * Gets or sets the position of the active row.
    */
    activeRow?: number | string;
    /**
     * Gets or sets if the grid should notify on programmatic selection changes as well as changes from the UI.
    */
    notifyOnAllSelectionChanges?: boolean | string;
    /**
 * Called when the selected items change.
*/
    selectedItemsChanged?: (s: IgrListPanel, e: IgrListPanelSelectedItemsChangedEventArgs) => void;
    /**
     * Called when the selected keys change.
    */
    selectedKeysChanged?: (s: IgrListPanel, e: IgrListPanelSelectedKeysChangedEventArgs) => void;
    /**
     * Called when an individual selection operation has been made.
    */
    selectionChanged?: (s: IgrListPanel, e: IgrListPanelSelectionChangedEventArgs) => void;
    /**
     * Called when the active row changes.
    */
    activeRowChanged?: (s: IgrListPanel, e: IgrListPanelActiveRowChangedEventArgs) => void;
    contentRefreshed?: (s: IgrListPanel, e: IgrListPanelContentRefreshedEventArgs) => void;
    rowUpdating?: (s: IgrListPanel, e: IgrListPanelTemplateItemUpdatingEventArgs) => void;
    itemWidthRequested?: (s: IgrListPanel, e: IgrListPanelTemplateWidthRequestedEventArgs) => void;
    itemHeightRequested?: (s: IgrListPanel, e: IgrListPanelTemplateHeightRequestedEventArgs) => void;
    itemClicked?: (s: IgrListPanel, e: IgrListPanelItemEventArgs) => void;
}
