import { ToolActionButtonGroupDisplayType } from "./ToolActionButtonGroupDisplayType";
import { IgrToolAction, IIgrToolActionProps } from "./igr-tool-action";
import { ToolActionButtonPair } from "./ToolActionButtonPair";
export declare class IgrToolActionButtonPair extends IgrToolAction<IIgrToolActionButtonPairProps> {
    protected createImplementation(): ToolActionButtonPair;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionButtonPair;
    constructor(props: IIgrToolActionButtonPairProps);
    get leftIsSelected(): boolean;
    set leftIsSelected(v: boolean);
    get rightIsSelected(): boolean;
    set rightIsSelected(v: boolean);
    get leftIsDisabled(): boolean;
    set leftIsDisabled(v: boolean);
    get rightIsDisabled(): boolean;
    set rightIsDisabled(v: boolean);
    get leftIconName(): string;
    set leftIconName(v: string);
    get leftCommandArgument(): string;
    set leftCommandArgument(v: string);
    get isToggleDisabled(): boolean;
    set isToggleDisabled(v: boolean);
    get leftIconCollectionName(): string;
    set leftIconCollectionName(v: string);
    /**
     * Gets or sets the LeftIcon viewbox left.
    */
    get leftIconViewBoxLeft(): number;
    set leftIconViewBoxLeft(v: number);
    /**
     * Gets or sets the LeftIcon viewbox top.
    */
    get leftIconViewBoxTop(): number;
    set leftIconViewBoxTop(v: number);
    /**
     * Gets or sets the LeftIcon viewbox width.
    */
    get leftIconViewBoxWidth(): number;
    set leftIconViewBoxWidth(v: number);
    /**
     * Gets or sets the LeftIcon viewbox height.
    */
    get leftIconViewBoxHeight(): number;
    set leftIconViewBoxHeight(v: number);
    /**
     * Gets or sets the LeftIcon fill color.
    */
    get leftIconFill(): string;
    set leftIconFill(v: string);
    /**
     * Gets the actual LeftIcon fill color.
    */
    get actualLeftIconFill(): string;
    set actualLeftIconFill(v: string);
    /**
     * Gets or sets the LeftIcon fill colors.
    */
    get leftIconFillColors(): string[];
    set leftIconFillColors(v: string[]);
    /**
     * Gets or sets the LeftIcon stroke color.
    */
    get leftIconStroke(): string;
    set leftIconStroke(v: string);
    /**
     * Gets the actual LeftIcon stroke color.
    */
    get actualLeftIconStroke(): string;
    set actualLeftIconStroke(v: string);
    /**
     * Gets or sets the LeftIcon stroke colors.
    */
    get leftIconStrokeColors(): string[];
    set leftIconStrokeColors(v: string[]);
    /**
     * Gets or sets the LeftIcon viewbox width.
    */
    get leftIconStrokeWidth(): number;
    set leftIconStrokeWidth(v: number);
    /**
     * Gets or sets the title of the left button.
    */
    get leftTitle(): string;
    set leftTitle(v: string);
    get rightIconName(): string;
    set rightIconName(v: string);
    get rightCommandArgument(): string;
    set rightCommandArgument(v: string);
    get rightIconCollectionName(): string;
    set rightIconCollectionName(v: string);
    /**
     * Gets or sets the RightIcon viewbox left.
    */
    get rightIconViewBoxLeft(): number;
    set rightIconViewBoxLeft(v: number);
    /**
     * Gets or sets the RightIcon viewbox top.
    */
    get rightIconViewBoxTop(): number;
    set rightIconViewBoxTop(v: number);
    /**
     * Gets or sets the RightIcon viewbox width.
    */
    get rightIconViewBoxWidth(): number;
    set rightIconViewBoxWidth(v: number);
    /**
     * Gets or sets the RightIcon viewbox height.
    */
    get rightIconViewBoxHeight(): number;
    set rightIconViewBoxHeight(v: number);
    /**
     * Gets or sets the RightIcon fill color.
    */
    get rightIconFill(): string;
    set rightIconFill(v: string);
    /**
     * Gets the actual RightIcon fill color.
    */
    get actualRightIconFill(): string;
    set actualRightIconFill(v: string);
    /**
     * Gets or sets the RightIcon fill colors.
    */
    get rightIconFillColors(): string[];
    set rightIconFillColors(v: string[]);
    /**
     * Gets or sets the RightIcon stroke color.
    */
    get rightIconStroke(): string;
    set rightIconStroke(v: string);
    /**
     * Gets the actual RightIcon stroke color.
    */
    get actualRightIconStroke(): string;
    set actualRightIconStroke(v: string);
    /**
     * Gets or sets the RightIcon stroke colors.
    */
    get rightIconStrokeColors(): string[];
    set rightIconStrokeColors(v: string[]);
    /**
     * Gets or sets the RightIcon viewbox width.
    */
    get rightIconStrokeWidth(): number;
    set rightIconStrokeWidth(v: number);
    /**
     * Gets or sets the title of the Right button.
    */
    get rightTitle(): string;
    set rightTitle(v: string);
    /**
     * Gets or sets the display type for the button.
    */
    get displayType(): ToolActionButtonGroupDisplayType;
    set displayType(v: ToolActionButtonGroupDisplayType);
    /**
     * Gets or sets the button corner radius.
    */
    get cornerRadius(): number;
    set cornerRadius(v: number);
}
export interface IIgrToolActionButtonPairProps extends IIgrToolActionProps {
    leftIsSelected?: boolean | string;
    rightIsSelected?: boolean | string;
    leftIsDisabled?: boolean | string;
    rightIsDisabled?: boolean | string;
    leftIconName?: string;
    leftCommandArgument?: string;
    isToggleDisabled?: boolean | string;
    leftIconCollectionName?: string;
    /**
     * Gets or sets the LeftIcon viewbox left.
    */
    leftIconViewBoxLeft?: number | string;
    /**
     * Gets or sets the LeftIcon viewbox top.
    */
    leftIconViewBoxTop?: number | string;
    /**
     * Gets or sets the LeftIcon viewbox width.
    */
    leftIconViewBoxWidth?: number | string;
    /**
     * Gets or sets the LeftIcon viewbox height.
    */
    leftIconViewBoxHeight?: number | string;
    /**
     * Gets or sets the LeftIcon fill color.
    */
    leftIconFill?: string;
    /**
     * Gets the actual LeftIcon fill color.
    */
    actualLeftIconFill?: string;
    /**
     * Gets or sets the LeftIcon fill colors.
    */
    leftIconFillColors?: string[] | string;
    /**
     * Gets or sets the LeftIcon stroke color.
    */
    leftIconStroke?: string;
    /**
     * Gets the actual LeftIcon stroke color.
    */
    actualLeftIconStroke?: string;
    /**
     * Gets or sets the LeftIcon stroke colors.
    */
    leftIconStrokeColors?: string[] | string;
    /**
     * Gets or sets the LeftIcon viewbox width.
    */
    leftIconStrokeWidth?: number | string;
    /**
     * Gets or sets the title of the left button.
    */
    leftTitle?: string;
    rightIconName?: string;
    rightCommandArgument?: string;
    rightIconCollectionName?: string;
    /**
     * Gets or sets the RightIcon viewbox left.
    */
    rightIconViewBoxLeft?: number | string;
    /**
     * Gets or sets the RightIcon viewbox top.
    */
    rightIconViewBoxTop?: number | string;
    /**
     * Gets or sets the RightIcon viewbox width.
    */
    rightIconViewBoxWidth?: number | string;
    /**
     * Gets or sets the RightIcon viewbox height.
    */
    rightIconViewBoxHeight?: number | string;
    /**
     * Gets or sets the RightIcon fill color.
    */
    rightIconFill?: string;
    /**
     * Gets the actual RightIcon fill color.
    */
    actualRightIconFill?: string;
    /**
     * Gets or sets the RightIcon fill colors.
    */
    rightIconFillColors?: string[] | string;
    /**
     * Gets or sets the RightIcon stroke color.
    */
    rightIconStroke?: string;
    /**
     * Gets the actual RightIcon stroke color.
    */
    actualRightIconStroke?: string;
    /**
     * Gets or sets the RightIcon stroke colors.
    */
    rightIconStrokeColors?: string[] | string;
    /**
     * Gets or sets the RightIcon viewbox width.
    */
    rightIconStrokeWidth?: number | string;
    /**
     * Gets or sets the title of the Right button.
    */
    rightTitle?: string;
    /**
     * Gets or sets the display type for the button.
    */
    displayType?: ToolActionButtonGroupDisplayType | string;
    /**
     * Gets or sets the button corner radius.
    */
    cornerRadius?: number | string;
}
