import { IgrLayoutSelectedItemsCollection } from "./igr-layout-selected-items-collection";
import { IgrToolAction, IIgrToolActionProps } from "./igr-tool-action";
import { ToolActionCombo } from "./ToolActionCombo";
export declare class IgrToolActionCombo extends IgrToolAction<IIgrToolActionComboProps> {
    protected createImplementation(): ToolActionCombo;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionCombo;
    constructor(props: IIgrToolActionComboProps);
    /**
     * Gets or sets if the tool action is checked.
    */
    get dataSource(): any;
    set dataSource(v: any);
    /**
     * Gets or sets the field to use to get the displayed values.
    */
    get displayMemberPath(): string;
    set displayMemberPath(v: string);
    /**
     * Gets or sets the field to use to get the values to use.
    */
    get valueMemberPath(): string;
    set valueMemberPath(v: string);
    private _selectedValues;
    /**
    
    */
    get selectedValues(): IgrLayoutSelectedItemsCollection;
    set selectedValues(v: IgrLayoutSelectedItemsCollection);
}
export interface IIgrToolActionComboProps extends IIgrToolActionProps {
    /**
     * Gets or sets if the tool action is checked.
    */
    dataSource?: any;
    /**
     * Gets or sets the field to use to get the displayed values.
    */
    displayMemberPath?: string;
    /**
     * Gets or sets the field to use to get the values to use.
    */
    valueMemberPath?: string;
    /**
    
    */
    selectedValues?: IgrLayoutSelectedItemsCollection | string;
}
